var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __export = (target, all) => {
  __markAsModule(target);
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && key !== "default")
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toModule = (module2) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", module2 && module2.__esModule && "default" in module2 ? { get: () => module2.default, enumerable: true } : { value: module2, enumerable: true })), module2);
};

// src/index.ts
__export(exports, {
  useCheatCode: () => useCheatCode,
  useSecretCode: () => useSecretCode
});
var React = __toModule(require("react"));
var import_model = __toModule(require("xstate/lib/model"));
var import_react = __toModule(require("@xstate/react"));

// src/utils.ts
function isEqual(array1, array2) {
  return JSON.stringify(array1) === JSON.stringify(array2);
}
function takeRight(array, n) {
  if (n < 1)
    return [];
  return array.slice(-1 * n);
}

// src/index.ts
var initialContext = {
  cheatCodeKeys: void 0,
  typedKeys: []
};
var creators = {
  events: {
    keydown: (event) => ({ key: event.key })
  }
};
var cheatCodeModel = (0, import_model.createModel)(initialContext, creators);
var resetTypedKeys = cheatCodeModel.assign({
  typedKeys: initialContext.typedKeys
});
var record = cheatCodeModel.assign({
  typedKeys: (context, event) => [...context.typedKeys, event.key]
}, "keydown");
var cheatCodeMachine = cheatCodeModel.createMachine({
  id: "cheatCodeMachine",
  initial: "disabled",
  states: {
    disabled: {
      id: "disabled",
      initial: "idle",
      states: {
        idle: {
          always: [
            {
              cond: "cheatCodeEntered",
              actions: [resetTypedKeys],
              target: "#enabled"
            }
          ],
          on: {
            keydown: {
              actions: [record],
              target: "recording"
            }
          }
        },
        recording: {
          always: [
            {
              cond: "cheatCodeEntered",
              actions: [resetTypedKeys],
              target: "#enabled"
            }
          ],
          on: {
            keydown: {
              actions: [record],
              target: "recording"
            }
          },
          after: {
            doneTyping: {
              actions: [resetTypedKeys],
              target: "idle"
            }
          }
        }
      }
    },
    enabled: {
      id: "enabled",
      initial: "idle",
      states: {
        idle: {
          always: [
            {
              cond: "cheatCodeEntered",
              actions: [resetTypedKeys],
              target: "#disabled"
            }
          ],
          on: {
            keydown: {
              actions: [record],
              target: "recording"
            }
          }
        },
        recording: {
          always: [
            {
              cond: "cheatCodeEntered",
              actions: [resetTypedKeys],
              target: "#disabled"
            }
          ],
          on: {
            keydown: {
              actions: [record],
              target: "recording"
            }
          },
          after: {
            doneTyping: {
              actions: [resetTypedKeys],
              target: "idle"
            }
          }
        }
      }
    }
  }
}, {
  delays: {
    doneTyping: 2e3
  },
  guards: {
    cheatCodeEntered: (context) => Array.isArray(context.cheatCodeKeys) && isEqual(takeRight(context.typedKeys, context.cheatCodeKeys.length), context.cheatCodeKeys)
  }
});
function useCheatCode(cheatCodeKeys) {
  const machineOpts = React.useMemo(() => ({
    context: { cheatCodeKeys }
  }), [cheatCodeKeys]);
  const [state, send] = (0, import_react.useMachine)(cheatCodeMachine, machineOpts);
  React.useEffect(() => {
    const handleKeyboardEvent = (event) => {
      send(cheatCodeModel.events.keydown(event));
    };
    window.addEventListener("keydown", handleKeyboardEvent);
    return () => {
      window.removeEventListener("keydown", handleKeyboardEvent);
    };
  }, [send]);
  return state.matches("enabled");
}
var useSecretCode = useCheatCode;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  useCheatCode,
  useSecretCode
});
//# sourceMappingURL=index.js.map
